/*
 * UNC0xx host-side software. (c) Unicontrollers, Ltd., 2010-2014
 *
 * Please see the files README, COPYING, LICENSE and WARRANTY
 * for some useful details on the legal status of this code.
 * Visit the site http://www.unicontrollers.com for more info.
 *
 * file unc0xx_hdl.h
 * Defines the common device handler structure
 *
 * Please note you SHOULD NOT include this file from your programs as
 * the stuff it contains is internal to the library and can be changed
 * without a notice.
 *
 * Written by Andrey V. Stolyarov
 *
 */


#ifndef UNC0XX_HDL_H_SENTRY
#define UNC0XX_HDL_H_SENTRY


struct unc0xx_devhdl;

enum {
    unc0xx_msg_const,  /* it is a constant, just remember the pointer */
    unc0xx_msg_own,    /* take the ownership */
    unc0xx_msg_copy    /* make your own copy */
};

struct unc0xx_devhdl_methods {
    int (*get)(struct unc0xx_devhdl *, int, void *, int);
                        /* handle, query_id, buf, buflen */

    int (*send)(struct unc0xx_devhdl *, const void *, int);
                        /* handle, buf, buflen */

    int (*close)(struct unc0xx_devhdl *);
                        /* handle */

    int (*takeover_stream)(struct unc0xx_devhdl *);
                        /* handle */

    int (*read_stream)(struct unc0xx_devhdl *, char *);
                        /* handle, buffer[8] */
};

struct unc0xx_devhdl {
    struct unc0xx_devhdl_methods *vtbl;
    int version;   /* filled automatically by the configuration request */
    const char *message;
    int message_owned;
};

/* kinda non-virtual methods; remember, they are INTERNAL! */

void unc0xx_set_errormsg(struct unc0xx_devhdl *h, const char *msg, int mode);

#endif
