/*
 * UNC001 firmware. (c) Unicontrollers, Ltd., 2010
 *
 * Please see the files README, COPYING, LICENSE and WARRANTY
 * for some useful details on the legal status of this code.
 * Visit the site http://www.unicontrollers.com for more info.
 *
 * file led.c
 * Implements LED controlling functions
 *
 * Written by Andrey V. Stolyarov
 *
 */


#include "ucd.h"
#include "unc_prim.h"
#include "led.h"

#define LED_ON() (PORTB&=~(1<<2))
#define LED_OFF() (PORTB|=(1<<2))
#define LED_SWITCH() (PORTB^=(1<<2))
#define LED_IS_ON() (!(PORTB & (1<<2)))

#define LED_OFF_PERIOD  7     /* in iterations of the main loop */

static uint8_t led_off_counter = 0;

void init_led()
{
    LED_OFF();
    DDRB|=1<<2;
}

void blink_led()
{
    LED_ON();
    led_off_counter = LED_OFF_PERIOD;
}

void led_hook()
{
    if(LED_IS_ON() && (!--led_off_counter))
        LED_OFF();
}
