/*
 * UNC001 firmware. (c) Unicontrollers, Ltd., 2010-2011
 *
 * Please see the files README, COPYING, LICENSE and WARRANTY
 * for some useful details on the legal status of this code.
 * Visit the site http://www.unicontrollers.com for more info.
 *
 * file misc.c
 * miscellaneous functions
 *
 * Written by Andrey V. Stolyarov
 *
 */

#include <stdint.h>
#include "misc.h"

char hexdigit(uint8_t n) {
    if(n<=9) return n + '0';
    if(n<=15) return n - 10 + 'A';
    else return '?'; /* should never happen */
}

int8_t hexdig2num(char c)
{
    if(c>='0' && c<='9')
        return c - '0';
    if(c>='a' && c<='f')
        return c - 'a' + 10;
    if(c>='A' && c<='F')
        return c - 'A' + 10;
    return -1;
}

void memcpy_4b(uint8_t *dest, const uint8_t *src)
{
    int8_t i;
    for(i = 3; i >= 0; i--) dest[i] = src[i];
}

